package test;
import static org.junit.Assert.*;
import kadai.Hand;
import kadai.Tactics;
import kotae.Player;
import org.junit.Test;
public class PlayerTest {
	@Test
	public void testToString() {
		Player p = new Player("CurePiece");
		assertEquals("CurePiece:	0 wins, 0 looses and 0 draws.",p.toString());
		p = new Player("Sazae");
		assertEquals("Sazae:	0 wins, 0 looses and 0 draws.",p.toString());
	}
	@Test
	public void testGetHand() {
		Player p = new Player("Test");
		Tactics t = new Tactics0(new HandBuilder0());
		p.setTactics(t);
		Hand h = p.getHand();
		assertEquals(1,h.getNum());
	}
	@Test
	public void testDraw() {
		Player p = new Player("Test");
		p.draw();
		assertEquals("Test:	0 wins, 0 looses and 1 draws.",p.toString());
		p.draw();
		assertEquals("Test:	0 wins, 0 looses and 2 draws.",p.toString());
	}
	@Test
	public void testWin() {
		Player p = new Player("Test");
		p.win();
		assertEquals("Test:	1 wins, 0 looses and 0 draws.",p.toString());
		p.win();
		assertEquals("Test:	2 wins, 0 looses and 0 draws.",p.toString());
	}
	@Test
	public void testLoose() {
		Player p = new Player("Test");
		p.loose();
		assertEquals("Test:	0 wins, 1 looses and 0 draws.",p.toString());
		p.loose();
		assertEquals("Test:	0 wins, 2 looses and 0 draws.",p.toString());
	}
}
